Subject: Re: [Teas] draft-ietf-teas-yang-path-computation-02 : path computation stateless RPC attributes

From: Igor Bryskin <[email-masked]>
Date: Fri, 27 Jul 2018 19:33:18 +0000

Hi Daniele,
Please, see in line.

Igor
From:Daniele Ceccarelli
To:Igor Bryskin,[email-masked],[email-masked],[email-masked],
Cc:Francesco Lazzeri,[email-masked],[email-masked],[email-masked],[email-masked],[email-masked],Carlo Perocchio,Leeyoung,[email-masked],[email-masked],[email-masked],Italo Busi,
Date:2018-07-27 02:29:14
Subject:RE: [Teas] draft-ietf-teas-yang-path-computation-02 : path computation stateless RPC attributes

Hi Igor,

what you are describing is just one of the use cases.

  *   Statefull path computation: I want the request/response to be guaranteed along the same path returned via path computation response.

IB》No, I am not talking about this. I want the stateless path computation to be as accurate as possible. One cannot say more about a tunnel than what could be provided as the tunnel configuration, so if a path computation request contains the entire tunnel configuration, there is no reason for the path computation to return one path, while the tunnel configured at the same  time (at least on a static network) to take a different path even under condition of policies installed on the server  unknown to the client. This is a useful improvement in accuracy of the stateless path computation for a very small price of a few optional parameters to pass.
Also bear in mind that stateless path computation could be requested not just for new tunnels, but also for existing tunnels, which means two things:
1. Not only the tunnel configuration should be considered, bur the entire tunnel state as well, in particular, all tunnel's current nominal and restored connection paths(e.g. to avoid double-booking).
2. Additional policies could be in place WRT tunnel optimization and other user controlled replacement.

  *   Stateless path computation: I don’t really care about the path, I just want to know that a path exists with given characteristics between A and B.

IB》For me this is equivalent to call a bank where I have a checking account of $10 000, and learn that this bank branch has $10 000 000 000 of cash at the moment. What can I do with this information?

Here we’re talking about stateless path computation. As I said before if a H-PCE needs to find the best path across multiple domains and there are different links/nodes that allow going from one domain to the other, the number of iterations between the H-PCE and the various PCE is huge, hence it should be very simple and in 99% of the cases who cares about an intra domain path? The only thing that cares is that between two border nodes there are X Gbps with given TE characteristics.

IB》Again, how do you know that the final resulting path is allowed for the tunnel you have in mind?

Cheers
Daniele

From: Igor Bryskin <[email-masked]>
Sent: giovedì 26 luglio 2018 16:50
To: Daniele Ceccarelli <[email-masked]>; [email-masked]; [email-masked]; [email-masked]
Cc: Francesco Lazzeri <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Carlo Perocchio <[email-masked]>; Leeyoung <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; Italo Busi <[email-masked]>
Subject: Re: [Teas] draft-ietf-teas-yang-path-computation-02 : path computation stateless RPC attributes

Daniele,
What is the point of path computation request / response if it can not be guaranteed, generally speaking, that a TE tunnel configured on a given network will take the same path as returned via path computation response?
The policies installed in the network are not expected to be known to all clients, but the policies could significantly  influence  on tunnel routing.
All we are saying is that when the same information is passed for tunnel configuration and in path computation request for the tunnel  in questuon, there will be no reason for a path computation return one path, while the actual tunnel, when requested,  taking  a different one.
Note also that all extra parameters we are talking about are optional and could be omitted in path computation RPC if it is known, for example, from experience that they do not affect the actual tunnel routing.

Igor
From:Daniele Ceccarelli
To:Belotti, Sergio (Nokia - IT/Vimercate),TEAS WG,[email-masked],
Cc:Francesco Lazzeri,Sethuraman, Karthik,Scharf, Michael (Nokia - DE/Stuttgart),Victor Lopez,OSCAR GONZALEZ DE DIOS ([email-masked]),Beller<mailto:[email-masked]),Beller>, Dieter (Nokia - DE/Stuttgart),Carlo Perocchio,Leeyoung,Anurag Sharma ([email-masked]),Ricard<mailto:[email-masked]),Ricard> Vilalta,[email-masked],Italo Busi,
Date:2018-07-26 05:54:16
Subject:Re: [Teas] draft-ietf-teas-yang-path-computation-02 : path computation stateless RPC attributes

Hi,

>The question is: are there benefits in including in input of Path Computation Request RPC also te-tunnel attributes without any foreseen recommended usage by path computation engine?

Absolutely no.

Main reasons:

  1.  Policies might not be shared with the MDSC
  2.  Policies may be different from PNC to PNC
  3.  A high number of path computation results will be discarded (stateless path computation is needed also by the MDSC to understand what are the different options to get from a node in a domain to another node in a different domain and possibly through a number of other domains…hence a high number of comination)
  4.  Last but not least simplification.

BR
Daniele

From: Belotti, Sergio (Nokia - IT/Vimercate) <sergio.belotti@nokia..com<mailto:sergio.belotti@nokia..com>>
Sent: giovedì 26 luglio 2018 11:00
To: TEAS WG <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
Cc: Italo Busi <[email-masked]<mailto:[email-masked]>>; Belotti, Sergio (Nokia - IT/Vimercate) <[email-masked]<mailto:[email-masked]>>; Francesco Lazzeri <[email-masked]<mailto:[email-masked]>>; Carlo Perocchio <[email-masked]<mailto:[email-masked]>>; Scharf, Michael (Nokia - DE/Stuttgart) <[email-masked]<mailto:[email-masked]>>; Anurag Sharma ([email-masked]<mailto:[email-masked]>) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Ricard Vilalta <[email-masked]<mailto:[email-masked]>>; OSCAR GONZALEZ DE DIOS ([email-masked]<mailto:[email-masked]>) <[email-masked]<mailto:[email-masked]>>; Victor Lopez <[email-masked]<mailto:[email-masked]>>; Daniele Ceccarelli <[email-masked]<mailto:[email-masked]>>; Beller, Dieter (Nokia - DE/Stuttgart) <[email-masked]<mailto:[email-masked]>>; Sethuraman, Karthik <[email-masked]<mailto:[email-masked]>>
Subject: draft-ietf-teas-yang-path-computation-02 : path computation stateless RPC attributes

Hi all,

After the discussion held during the last TEAS WG session in IETF102 and some offline talks, we are trying to summarize the questions that we need to answer to resolve the open issue 31 (reference for background https://github.com/rvilalta/ietf-te-path-computation/issues/31) .

The question is: are there benefits in including in input of Path Computation Request RPC also te-tunnel attributes without any foreseen recommended usage by path computation engine? For example this is the case of administration attributes such as 'tunnel description' or of those attributes that are relevant only for the provisioning phase e.g provisioning-state... Please consider that the question is in the scope of a 'Stateless-Path-Computation' service: no state or data is saved by PCE after RPC output is returned to the client.

One of the main use case for the Path Computation RPC design is to support multi domain path computation. In this case the MDSC (the RPC client) addresses to a PNC (the RPC server) a request to compute a path within the PNC native/controlled topology during the quest for a multi-domain path at a given time T1; at a later time T2 (once, for example, the e2e path is identified) MDSC requests southbound to PNC per domain Tunnel setup (the segments of the multi-domain tunnel) with either the same or different metrics and constraints (MDSC implementation decision), to guarantee that the PNC would setup a path equivalent or better than the one computed at time T1.

Example: the MDSC computes a multi-domain end-to-end path between points A and Z and selects a path having te-metric 100. The path A-Z passes through the  domain controlled by PNC  X, entering in B and exiting in C, for which path computation RPC has returned a B-C path with te-metric 20. When asking  PNC X to setup the path B-C, a constraint on te-metric must be provided in order to avoid PNC X finding a suitable path satisfying all the other constraints of the end-to-end path but with te-metric higher than 20. If a different path is found with a metric < 20, that's fine. So, it's not essential that the same identical path is produced at the second path computation. The only requirement is on its metrics.

 Depending on the abstraction level applied by the domain controller the client may never know the actual computed path: the only important requirement is that the path metrics and constraints are met.
Therefore it is not necessary to guaranteed that the path setup at time T2 is exactly the same as the path computed at time T1 but only that it has the same or better metrics.

Regarding the policies, it has been said in the ietf meeting (see the relevant transcript) that they allow a "private" behavior of the server triggered by a condition depending possibly on any attribute of the tunnel request. This actually prevents a client application to perform autonomously the end-to-end path computation (e.g. using detailed connectivity matrix), as it doesn't know how each domain will behave when recomputing the tunnel for deployment (and so applying policies the client doesn't know and which could be even different for different domains).
In order to prevent this, policies should be explicitly shared with the clients, and be included in the detailed connectivity matrix information exposed by each domain to take into account not only the possible alternative path computation parameters, but also all the possible combinations of applicable policies. The client shall then select the suitable detailed connectivity matrix taking into account both the path computation parameters AND the applicable policies.
When such policy attributes are defined, they will be included in the path computation RPC.

Italo and Sergio (on behalf of co-authors/contributors)

Sergio Belotti
Senior System Engineer and Standardization Architect
IP/Optical Networks, Optics BU
Nokia
M: +39-335761776
Via Energy Park, 20871 Vimercate (MB) , Italy
[email-masked]<mailto:[email-masked]>